# shithook

An inline hooking library for windows.

# usage

Installing the hook/Init.
```cpp
hook::install(
    &WriteFile,     //address to put inline hook at.
    &HookWriteFile  //address to jmp too.
);
```

Disabling the hook so you can call the original function.
```cpp
 hook::disable(&WriteFile);
 WriteFile(.....)
```

Enabling the hook.
```
hook::enable(&WriteFile);
```

# info

All hooks are stored inside of a `std::map<std::uintptr_t, std::unique_ptr<detour>>` for quick and easy access to each object. All functions
interacting with this vector will use the address of the inline hook as the key so make sure the address is easy to access in your code! 

Keep in mind that this is an inline hooking library so you will need to uninstall the hook to call the actual function. Dont forget to reinstall your hooks!